package rtflow;

public class RTflowCode {
   /** The array of all boolean signals. */
   private boolean[] b = new boolean[110];

   /** The array of all integer signals. */
   private int[] i = new int[10];

   /** The array of all real-valued signals. */
   private float[] r = new float[230];

   /** The RTflow model names of all boolean signals. */
   public String[] boolNames = new String[] {
      "thrust",
      "left",
      "fire",
      "right",
      "bullet1",
      "bullet2",
      "thrust2",
      "thrust1",
      "MyAI1_left_1",
      "MyAI1_right_1",
      "MyAI1_fire_1",
      "Plant1/hit1on2",
      "Plant1/hit2on1",
      "Plant1/Ship1/pre_unfire",
      "Plant1/Ship1/unfire",
      "Plant1/Ship1/outside_screen",
      "Plant1/Ship1/Position1/out_x",
      "Plant1/Ship1/Position1/out_y",
      "Plant1/Ship1/Position1/OutsideScreen1/x_low",
      "Plant1/Ship1/Position1/OutsideScreen1/y_hi",
      "Plant1/Ship1/Position1/OutsideScreen1/outside",
      "Plant1/Ship1/Position1/OutsideScreen1/x_hi",
      "Plant1/Ship1/Position1/OutsideScreen1/y_low",
      "Plant1/Ship1/Position1/SpeedX/negate_edge",
      "Plant1/Ship1/Position1/SpeedX/PositiveEdge1/Not1_o_1",
      "Plant1/Ship1/Position1/SpeedX/PositiveEdge1/Pre2_o_1",
      "Plant1/Ship1/Position1/SpeedY/negate_edge",
      "Plant1/Ship1/Position1/SpeedY/PositiveEdge1/Not1_o_1",
      "Plant1/Ship1/Position1/SpeedY/PositiveEdge1/Pre2_o_1",
      "Plant1/Ship1/Bullet1/true_fire",
      "Plant1/Ship1/Bullet1/SetReset1/set_value",
      "Plant1/Ship1/Bullet1/SetReset1/set_edge",
      "Plant1/Ship1/Bullet1/SetReset1/pre",
      "Plant1/Ship1/Bullet1/SetReset1/reset_value",
      "Plant1/Ship1/Bullet1/SetReset1/pre_or_set",
      "Plant1/Ship1/Bullet1/SetReset1/reset_edge",
      "Plant1/Ship1/Bullet1/SetReset1/PositiveEdge1/Not1_o_1",
      "Plant1/Ship1/Bullet1/SetReset1/PositiveEdge1/Pre2_o_1",
      "Plant1/Ship1/Bullet1/SetReset1/PositiveEdge2/Not1_o_1",
      "Plant1/Ship1/Bullet1/SetReset1/PositiveEdge2/Pre2_o_1",
      "Plant1/Ship1/Bullet1/PositiveEdge1/Not1_o_1",
      "Plant1/Ship1/Bullet1/PositiveEdge1/Pre2_o_1",
      "Plant1/Ship1/OutsideScreen1/x_low",
      "Plant1/Ship1/OutsideScreen1/x_outside",
      "Plant1/Ship1/OutsideScreen1/y_hi",
      "Plant1/Ship1/OutsideScreen1/y_outside",
      "Plant1/Ship1/OutsideScreen1/x_hi",
      "Plant1/Ship1/OutsideScreen1/y_low",
      "Plant1/Ship2/pre_unfire",
      "Plant1/Ship2/unfire",
      "Plant1/Ship2/outside_screen",
      "Plant1/Ship2/Position1/out_x",
      "Plant1/Ship2/Position1/out_y",
      "Plant1/Ship2/Position1/OutsideScreen1/x_low",
      "Plant1/Ship2/Position1/OutsideScreen1/y_hi",
      "Plant1/Ship2/Position1/OutsideScreen1/outside",
      "Plant1/Ship2/Position1/OutsideScreen1/x_hi",
      "Plant1/Ship2/Position1/OutsideScreen1/y_low",
      "Plant1/Ship2/Position1/SpeedX/negate_edge",
      "Plant1/Ship2/Position1/SpeedX/PositiveEdge1/Not1_o_1",
      "Plant1/Ship2/Position1/SpeedX/PositiveEdge1/Pre2_o_1",
      "Plant1/Ship2/Position1/SpeedY/negate_edge",
      "Plant1/Ship2/Position1/SpeedY/PositiveEdge1/Not1_o_1",
      "Plant1/Ship2/Position1/SpeedY/PositiveEdge1/Pre2_o_1",
      "Plant1/Ship2/Bullet1/true_fire",
      "Plant1/Ship2/Bullet1/SetReset1/set_value",
      "Plant1/Ship2/Bullet1/SetReset1/set_edge",
      "Plant1/Ship2/Bullet1/SetReset1/pre",
      "Plant1/Ship2/Bullet1/SetReset1/reset_value",
      "Plant1/Ship2/Bullet1/SetReset1/pre_or_set",
      "Plant1/Ship2/Bullet1/SetReset1/reset_edge",
      "Plant1/Ship2/Bullet1/SetReset1/PositiveEdge1/Not1_o_1",
      "Plant1/Ship2/Bullet1/SetReset1/PositiveEdge1/Pre2_o_1",
      "Plant1/Ship2/Bullet1/SetReset1/PositiveEdge2/Not1_o_1",
      "Plant1/Ship2/Bullet1/SetReset1/PositiveEdge2/Pre2_o_1",
      "Plant1/Ship2/Bullet1/PositiveEdge1/Not1_o_1",
      "Plant1/Ship2/Bullet1/PositiveEdge1/Pre2_o_1",
      "Plant1/Ship2/OutsideScreen1/x_low",
      "Plant1/Ship2/OutsideScreen1/x_outside",
      "Plant1/Ship2/OutsideScreen1/y_hi",
      "Plant1/Ship2/OutsideScreen1/y_outside",
      "Plant1/Ship2/OutsideScreen1/x_hi",
      "Plant1/Ship2/OutsideScreen1/y_low",
      "Plant1/Hit1On2/inside_radius",
      "Plant1/Hit2On1/inside_radius",
      "MyAI1/left1",
      "MyAI1/right1",
      "MyAI1/AILeftRight1/NormalizeAngle1/negative",
      "MyAI1/AIThrust1/angle_thrust",
      "MyAI1/AIThrust1/speed_thrust",
      "MyAI1/AIThrust1/Abs1/is_negative",
      "MyAI1/AIFire1/angle_fire",
      "MyAI1/AIFire1/distance_fire",
      "MyAI1/AIFire1/Abs1/is_negative",
      "Plant1/Ship1/Position1/SpeedX/PositiveEdge1/Pre2",
      "Plant1/Ship1/Position1/SpeedY/PositiveEdge1/Pre2",
      "Plant1/Ship1/Bullet1/SetReset1/PositiveEdge1/Pre2",
      "Plant1/Ship1/Bullet1/SetReset1/PositiveEdge2/Pre2",
      "Plant1/Ship1/Bullet1/SetReset1/Pre1",
      "Plant1/Ship1/Bullet1/PositiveEdge1/Pre2",
      "Plant1/Ship1/Pre1",
      "Plant1/Ship2/Position1/SpeedX/PositiveEdge1/Pre2",
      "Plant1/Ship2/Position1/SpeedY/PositiveEdge1/Pre2",
      "Plant1/Ship2/Bullet1/SetReset1/PositiveEdge1/Pre2",
      "Plant1/Ship2/Bullet1/SetReset1/PositiveEdge2/Pre2",
      "Plant1/Ship2/Bullet1/SetReset1/Pre1",
      "Plant1/Ship2/Bullet1/PositiveEdge1/Pre2",
      "Plant1/Ship2/Pre1",
      "MyAI1/Pre1",
      "MyAI1/Pre2",
   };

   /** The RTflow model names of all integer signals. */
   public String[] intNames = new String[] {
      "hits1on2",
      "hits2on1",
      "Plant1/Hit1On2/Count2/pre_plus_1",
      "Plant1/Hit1On2/Count2/pre",
      "Plant1/Hit1On2/Count2/one",
      "Plant1/Hit2On1/Count2/pre_plus_1",
      "Plant1/Hit2On1/Count2/pre",
      "Plant1/Hit2On1/Count2/one",
      "Plant1/Hit1On2/Count2/Pre1",
      "Plant1/Hit2On1/Count2/Pre1",
   };

   /** The RTflow model names of all real-valued signals. */
   public String[] realNames = new String[] {
      "y1",
      "x1",
      "rot1",
      "x2",
      "rot2",
      "bulletx1",
      "bullety1",
      "y2",
      "bulletx2",
      "bullety2",
      "Plant1/startx",
      "Plant1/startx2",
      "Plant1/Ship1/Rotation1/left1",
      "Plant1/Ship1/Rotation1/lk",
      "Plant1/Ship1/Rotation1/right1",
      "Plant1/Ship1/Rotation1/rotdir",
      "Plant1/Ship1/Rotation1/rotspeed",
      "Plant1/Ship1/Rotation1/startrot",
      "Plant1/Ship1/Rotation1/rotrel",
      "Plant1/Ship1/Rotation1/Integral1/pre_o",
      "Plant1/Ship1/Rotation1/Integral1/idt",
      "Plant1/Ship1/Rotation1/Integral1/dt",
      "Plant1/Ship1/Position1/gravitation",
      "Plant1/Ship1/Position1/cos",
      "Plant1/Ship1/Position1/accy",
      "Plant1/Ship1/Position1/px",
      "Plant1/Ship1/Position1/py",
      "Plant1/Ship1/Position1/thrust1",
      "Plant1/Ship1/Position1/t",
      "Plant1/Ship1/Position1/starty",
      "Plant1/Ship1/Position1/sin",
      "Plant1/Ship1/Position1/negsin",
      "Plant1/Ship1/Position1/accx",
      "Plant1/Ship1/Position1/ay",
      "Plant1/Ship1/Position1/sy",
      "Plant1/Ship1/Position1/sx",
      "Plant1/Ship1/Position1/Integral2/pre_o",
      "Plant1/Ship1/Position1/Integral2/idt",
      "Plant1/Ship1/Position1/Integral2/dt",
      "Plant1/Ship1/Position1/Integral4/pre_o",
      "Plant1/Ship1/Position1/Integral4/idt",
      "Plant1/Ship1/Position1/Integral4/dt",
      "Plant1/Ship1/Position1/Negation1/z",
      "Plant1/Ship1/Position1/OutsideScreen1/zero",
      "Plant1/Ship1/Position1/OutsideScreen1/width",
      "Plant1/Ship1/Position1/OutsideScreen1/height",
      "Plant1/Ship1/Position1/SpeedX/negative",
      "Plant1/Ship1/Position1/SpeedX/m",
      "Plant1/Ship1/Position1/SpeedX/dt",
      "Plant1/Ship1/Position1/SpeedX/a",
      "Plant1/Ship1/Position1/SpeedX/If1_o_1",
      "Plant1/Ship1/Position1/SpeedY/negative",
      "Plant1/Ship1/Position1/SpeedY/m",
      "Plant1/Ship1/Position1/SpeedY/dt",
      "Plant1/Ship1/Position1/SpeedY/a",
      "Plant1/Ship1/Position1/SpeedY/If1_o_1",
      "Plant1/Ship1/Bullet1/cos",
      "Plant1/Ship1/Bullet1/dir_x",
      "Plant1/Ship1/Bullet1/dir_y",
      "Plant1/Ship1/Bullet1/origin_y",
      "Plant1/Ship1/Bullet1/origin_x",
      "Plant1/Ship1/Bullet1/sin",
      "Plant1/Ship1/Bullet1/negsin",
      "Plant1/Ship1/Bullet1/speed_x",
      "Plant1/Ship1/Bullet1/relx",
      "Plant1/Ship1/Bullet1/speed_y",
      "Plant1/Ship1/Bullet1/rely",
      "Plant1/Ship1/Bullet1/D1/pre_o",
      "Plant1/Ship1/Bullet1/D2/pre_o",
      "Plant1/Ship1/Bullet1/D3/pre_o",
      "Plant1/Ship1/Bullet1/D4/pre_o",
      "Plant1/Ship1/Bullet1/Negation1/z",
      "Plant1/Ship1/Bullet1/Integral1/pre_o2",
      "Plant1/Ship1/Bullet1/Integral1/Mult1_o_1",
      "Plant1/Ship1/Bullet1/Integral1/Dt1_o_1",
      "Plant1/Ship1/Bullet1/Integral1/o1",
      "Plant1/Ship1/Bullet1/Integral1/Value1_o_1",
      "Plant1/Ship1/Bullet1/Integral2/pre_o2",
      "Plant1/Ship1/Bullet1/Integral2/Mult1_o_1",
      "Plant1/Ship1/Bullet1/Integral2/Dt1_o_1",
      "Plant1/Ship1/Bullet1/Integral2/o1",
      "Plant1/Ship1/Bullet1/Integral2/Value1_o_1",
      "Plant1/Ship1/OutsideScreen1/zero",
      "Plant1/Ship1/OutsideScreen1/width",
      "Plant1/Ship1/OutsideScreen1/height",
      "Plant1/Ship2/Rotation1/left1",
      "Plant1/Ship2/Rotation1/lk",
      "Plant1/Ship2/Rotation1/right1",
      "Plant1/Ship2/Rotation1/rotdir",
      "Plant1/Ship2/Rotation1/rotspeed",
      "Plant1/Ship2/Rotation1/startrot",
      "Plant1/Ship2/Rotation1/rotrel",
      "Plant1/Ship2/Rotation1/Integral1/pre_o",
      "Plant1/Ship2/Rotation1/Integral1/idt",
      "Plant1/Ship2/Rotation1/Integral1/dt",
      "Plant1/Ship2/Position1/gravitation",
      "Plant1/Ship2/Position1/cos",
      "Plant1/Ship2/Position1/accy",
      "Plant1/Ship2/Position1/px",
      "Plant1/Ship2/Position1/py",
      "Plant1/Ship2/Position1/thrust1",
      "Plant1/Ship2/Position1/t",
      "Plant1/Ship2/Position1/starty",
      "Plant1/Ship2/Position1/sin",
      "Plant1/Ship2/Position1/negsin",
      "Plant1/Ship2/Position1/accx",
      "Plant1/Ship2/Position1/ay",
      "Plant1/Ship2/Position1/sy",
      "Plant1/Ship2/Position1/sx",
      "Plant1/Ship2/Position1/Integral2/pre_o",
      "Plant1/Ship2/Position1/Integral2/idt",
      "Plant1/Ship2/Position1/Integral2/dt",
      "Plant1/Ship2/Position1/Integral4/pre_o",
      "Plant1/Ship2/Position1/Integral4/idt",
      "Plant1/Ship2/Position1/Integral4/dt",
      "Plant1/Ship2/Position1/Negation1/z",
      "Plant1/Ship2/Position1/OutsideScreen1/zero",
      "Plant1/Ship2/Position1/OutsideScreen1/width",
      "Plant1/Ship2/Position1/OutsideScreen1/height",
      "Plant1/Ship2/Position1/SpeedX/negative",
      "Plant1/Ship2/Position1/SpeedX/m",
      "Plant1/Ship2/Position1/SpeedX/dt",
      "Plant1/Ship2/Position1/SpeedX/a",
      "Plant1/Ship2/Position1/SpeedX/If1_o_1",
      "Plant1/Ship2/Position1/SpeedY/negative",
      "Plant1/Ship2/Position1/SpeedY/m",
      "Plant1/Ship2/Position1/SpeedY/dt",
      "Plant1/Ship2/Position1/SpeedY/a",
      "Plant1/Ship2/Position1/SpeedY/If1_o_1",
      "Plant1/Ship2/Bullet1/cos",
      "Plant1/Ship2/Bullet1/dir_x",
      "Plant1/Ship2/Bullet1/dir_y",
      "Plant1/Ship2/Bullet1/origin_y",
      "Plant1/Ship2/Bullet1/origin_x",
      "Plant1/Ship2/Bullet1/sin",
      "Plant1/Ship2/Bullet1/negsin",
      "Plant1/Ship2/Bullet1/speed_x",
      "Plant1/Ship2/Bullet1/relx",
      "Plant1/Ship2/Bullet1/speed_y",
      "Plant1/Ship2/Bullet1/rely",
      "Plant1/Ship2/Bullet1/D1/pre_o",
      "Plant1/Ship2/Bullet1/D2/pre_o",
      "Plant1/Ship2/Bullet1/D3/pre_o",
      "Plant1/Ship2/Bullet1/D4/pre_o",
      "Plant1/Ship2/Bullet1/Negation1/z",
      "Plant1/Ship2/Bullet1/Integral1/pre_o2",
      "Plant1/Ship2/Bullet1/Integral1/Mult1_o_1",
      "Plant1/Ship2/Bullet1/Integral1/Dt1_o_1",
      "Plant1/Ship2/Bullet1/Integral1/o1",
      "Plant1/Ship2/Bullet1/Integral1/Value1_o_1",
      "Plant1/Ship2/Bullet1/Integral2/pre_o2",
      "Plant1/Ship2/Bullet1/Integral2/Mult1_o_1",
      "Plant1/Ship2/Bullet1/Integral2/Dt1_o_1",
      "Plant1/Ship2/Bullet1/Integral2/o1",
      "Plant1/Ship2/Bullet1/Integral2/Value1_o_1",
      "Plant1/Ship2/OutsideScreen1/zero",
      "Plant1/Ship2/OutsideScreen1/width",
      "Plant1/Ship2/OutsideScreen1/height",
      "Plant1/Hit1On2/hit_radius",
      "Plant1/Hit1On2/distance",
      "Plant1/Hit1On2/Distance1/dx",
      "Plant1/Hit1On2/Distance1/dy",
      "Plant1/Hit1On2/Distance1/Length1/dx2",
      "Plant1/Hit1On2/Distance1/Length1/dy2",
      "Plant1/Hit1On2/Distance1/Length1/sum",
      "Plant1/Hit2On1/hit_radius",
      "Plant1/Hit2On1/distance",
      "Plant1/Hit2On1/Distance1/dx",
      "Plant1/Hit2On1/Distance1/dy",
      "Plant1/Hit2On1/Distance1/Length1/dx2",
      "Plant1/Hit2On1/Distance1/Length1/dy2",
      "Plant1/Hit2On1/Distance1/Length1/sum",
      "MyAI1/angle_diff",
      "MyAI1/distance",
      "MyAI1/AILeftRight1/dx",
      "MyAI1/AILeftRight1/dy",
      "MyAI1/AILeftRight1/angle",
      "MyAI1/AILeftRight1/angle_diff",
      "MyAI1/AILeftRight1/rotate_threshold",
      "MyAI1/AILeftRight1/neg_threshold",
      "MyAI1/AILeftRight1/NormalizeAngle1/pi",
      "MyAI1/AILeftRight1/NormalizeAngle1/piX2",
      "MyAI1/AILeftRight1/NormalizeAngle1/i_plus_pi",
      "MyAI1/AILeftRight1/NormalizeAngle1/zero",
      "MyAI1/AILeftRight1/NormalizeAngle1/modulus",
      "MyAI1/AILeftRight1/NormalizeAngle1/modulus_plus_pi",
      "MyAI1/AILeftRight1/NormalizeAngle1/zero_to_piX2",
      "MyAI1/AILeftRight1/Negation1/z",
      "MyAI1/AIThrust1/abs_diff",
      "MyAI1/AIThrust1/angle_threshold",
      "MyAI1/AIThrust1/speed_threshold",
      "MyAI1/AIThrust1/speed",
      "MyAI1/AIThrust1/Abs1/zero",
      "MyAI1/AIThrust1/Abs1/negative",
      "MyAI1/AIThrust1/Derivative1/pre_i",
      "MyAI1/AIThrust1/Derivative1/diff",
      "MyAI1/AIThrust1/Derivative1/Dt1_o_1",
      "MyAI1/AIFire1/abs_diff",
      "MyAI1/AIFire1/angle_threshold",
      "MyAI1/AIFire1/distance_threshold",
      "MyAI1/AIFire1/Abs1/zero",
      "MyAI1/AIFire1/Abs1/negative",
      "MyAI1/Distance1/dx",
      "MyAI1/Distance1/dy",
      "MyAI1/Distance1/Length1/dx2",
      "MyAI1/Distance1/Length1/dy2",
      "MyAI1/Distance1/Length1/sum",
      "Plant1/Ship1/Rotation1/Integral1/Pre1",
      "Plant1/Ship1/Position1/Integral2/Pre1",
      "Plant1/Ship1/Position1/Integral4/Pre1",
      "Plant1/Ship1/Position1/SpeedX/Pre3",
      "Plant1/Ship1/Position1/SpeedY/Pre3",
      "Plant1/Ship1/Bullet1/D1/Pre1",
      "Plant1/Ship1/Bullet1/D2/Pre1",
      "Plant1/Ship1/Bullet1/D3/Pre1",
      "Plant1/Ship1/Bullet1/D4/Pre1",
      "Plant1/Ship1/Bullet1/Integral1/Pre1",
      "Plant1/Ship1/Bullet1/Integral2/Pre1",
      "Plant1/Ship2/Rotation1/Integral1/Pre1",
      "Plant1/Ship2/Position1/Integral2/Pre1",
      "Plant1/Ship2/Position1/Integral4/Pre1",
      "Plant1/Ship2/Position1/SpeedX/Pre3",
      "Plant1/Ship2/Position1/SpeedY/Pre3",
      "Plant1/Ship2/Bullet1/D1/Pre1",
      "Plant1/Ship2/Bullet1/D2/Pre1",
      "Plant1/Ship2/Bullet1/D3/Pre1",
      "Plant1/Ship2/Bullet1/D4/Pre1",
      "Plant1/Ship2/Bullet1/Integral1/Pre1",
      "Plant1/Ship2/Bullet1/Integral2/Pre1",
      "MyAI1/AIThrust1/Derivative1/Pre1",
   };

   /** @return The array of all boolean signals. */
   public boolean[] getBoolArray() { return b; }

   /** @return The array of all integer signals. */
   public int[] getIntArray() { return i; }

   /** @return The array of all real-valued signals. */
   public float[] getRealArray() { return r; }

   /**
    * @return The real time in seconds corresponding to one execution cycle.
    */
   public float getSampleTime() {
      return 0.05f;
   }

   /**
    * Initializes the state of the system. Call this method once before
    * calling run().
    */
   public void initialize() {
      r[207] = 0f;             /* Plant1/Ship1/Rotation1/Integral1/Pre1 = 0f; */
      r[208] = 0f;             /* Plant1/Ship1/Position1/Integral2/Pre1 = 0f; */
      r[209] = 0f;             /* Plant1/Ship1/Position1/Integral4/Pre1 = 0f; */
      b[94] = false;           /* Plant1/Ship1/Position1/SpeedX/PositiveEdge1/Pre2 = false; */
      r[210] = 0f;             /* Plant1/Ship1/Position1/SpeedX/Pre3 = 0f; */
      b[95] = false;           /* Plant1/Ship1/Position1/SpeedY/PositiveEdge1/Pre2 = false; */
      r[211] = 0f;             /* Plant1/Ship1/Position1/SpeedY/Pre3 = 0f; */
      b[96] = false;           /* Plant1/Ship1/Bullet1/SetReset1/PositiveEdge1/Pre2 = false; */
      b[97] = false;           /* Plant1/Ship1/Bullet1/SetReset1/PositiveEdge2/Pre2 = false; */
      b[98] = false;           /* Plant1/Ship1/Bullet1/SetReset1/Pre1 = false; */
      b[99] = false;           /* Plant1/Ship1/Bullet1/PositiveEdge1/Pre2 = false; */
      r[212] = 0f;             /* Plant1/Ship1/Bullet1/D1/Pre1 = 0f; */
      r[213] = 0f;             /* Plant1/Ship1/Bullet1/D2/Pre1 = 0f; */
      r[214] = 0f;             /* Plant1/Ship1/Bullet1/D3/Pre1 = 0f; */
      r[215] = 0f;             /* Plant1/Ship1/Bullet1/D4/Pre1 = 0f; */
      r[216] = 0f;             /* Plant1/Ship1/Bullet1/Integral1/Pre1 = 0f; */
      r[217] = 0f;             /* Plant1/Ship1/Bullet1/Integral2/Pre1 = 0f; */
      b[100] = false;          /* Plant1/Ship1/Pre1 = false; */
      r[218] = 0f;             /* Plant1/Ship2/Rotation1/Integral1/Pre1 = 0f; */
      r[219] = 0f;             /* Plant1/Ship2/Position1/Integral2/Pre1 = 0f; */
      r[220] = 0f;             /* Plant1/Ship2/Position1/Integral4/Pre1 = 0f; */
      b[101] = false;          /* Plant1/Ship2/Position1/SpeedX/PositiveEdge1/Pre2 = false; */
      r[221] = 0f;             /* Plant1/Ship2/Position1/SpeedX/Pre3 = 0f; */
      b[102] = false;          /* Plant1/Ship2/Position1/SpeedY/PositiveEdge1/Pre2 = false; */
      r[222] = 0f;             /* Plant1/Ship2/Position1/SpeedY/Pre3 = 0f; */
      b[103] = false;          /* Plant1/Ship2/Bullet1/SetReset1/PositiveEdge1/Pre2 = false; */
      b[104] = false;          /* Plant1/Ship2/Bullet1/SetReset1/PositiveEdge2/Pre2 = false; */
      b[105] = false;          /* Plant1/Ship2/Bullet1/SetReset1/Pre1 = false; */
      b[106] = false;          /* Plant1/Ship2/Bullet1/PositiveEdge1/Pre2 = false; */
      r[223] = 0f;             /* Plant1/Ship2/Bullet1/D1/Pre1 = 0f; */
      r[224] = 0f;             /* Plant1/Ship2/Bullet1/D2/Pre1 = 0f; */
      r[225] = 0f;             /* Plant1/Ship2/Bullet1/D3/Pre1 = 0f; */
      r[226] = 0f;             /* Plant1/Ship2/Bullet1/D4/Pre1 = 0f; */
      r[227] = 0f;             /* Plant1/Ship2/Bullet1/Integral1/Pre1 = 0f; */
      r[228] = 0f;             /* Plant1/Ship2/Bullet1/Integral2/Pre1 = 0f; */
      b[107] = false;          /* Plant1/Ship2/Pre1 = false; */
      i[8] = 0;                /* Plant1/Hit1On2/Count2/Pre1 = 0; */
      i[9] = 0;                /* Plant1/Hit2On1/Count2/Pre1 = 0; */
      b[108] = false;          /* MyAI1/Pre1 = false; */
      b[109] = false;          /* MyAI1/Pre2 = false; */
      r[229] = 0f;             /* MyAI1/AIThrust1/Derivative1/Pre1 = 0f; */
   }

   /**
    * Executes one cycle. Every cycle, the calling code should:
    * 1) Provide the input signal values by writing into the arrays.
    * 2) Call the run() method.
    * 3) Collect the output signal values by reading from the arrays.
    */
   public void run() {
      // Output update equations
      r[19] = r[207];          /* Plant1/Ship1/Rotation1/Integral1/pre_o = Plant1/Ship1/Rotation1/Integral1/Pre1; */
      r[36] = r[208];          /* Plant1/Ship1/Position1/Integral2/pre_o = Plant1/Ship1/Position1/Integral2/Pre1; */
      r[39] = r[209];          /* Plant1/Ship1/Position1/Integral4/pre_o = Plant1/Ship1/Position1/Integral4/Pre1; */
      b[25] = b[94];           /* Plant1/Ship1/Position1/SpeedX/PositiveEdge1/Pre2_o_1 = Plant1/Ship1/Position1/SpeedX/PositiveEdge1/Pre2; */
      r[35] = r[210];          /* Plant1/Ship1/Position1/sx = Plant1/Ship1/Position1/SpeedX/Pre3; */
      b[28] = b[95];           /* Plant1/Ship1/Position1/SpeedY/PositiveEdge1/Pre2_o_1 = Plant1/Ship1/Position1/SpeedY/PositiveEdge1/Pre2; */
      r[34] = r[211];          /* Plant1/Ship1/Position1/sy = Plant1/Ship1/Position1/SpeedY/Pre3; */
      b[37] = b[96];           /* Plant1/Ship1/Bullet1/SetReset1/PositiveEdge1/Pre2_o_1 = Plant1/Ship1/Bullet1/SetReset1/PositiveEdge1/Pre2; */
      b[39] = b[97];           /* Plant1/Ship1/Bullet1/SetReset1/PositiveEdge2/Pre2_o_1 = Plant1/Ship1/Bullet1/SetReset1/PositiveEdge2/Pre2; */
      b[32] = b[98];           /* Plant1/Ship1/Bullet1/SetReset1/pre = Plant1/Ship1/Bullet1/SetReset1/Pre1; */
      b[41] = b[99];           /* Plant1/Ship1/Bullet1/PositiveEdge1/Pre2_o_1 = Plant1/Ship1/Bullet1/PositiveEdge1/Pre2; */
      r[67] = r[212];          /* Plant1/Ship1/Bullet1/D1/pre_o = Plant1/Ship1/Bullet1/D1/Pre1; */
      r[68] = r[213];          /* Plant1/Ship1/Bullet1/D2/pre_o = Plant1/Ship1/Bullet1/D2/Pre1; */
      r[69] = r[214];          /* Plant1/Ship1/Bullet1/D3/pre_o = Plant1/Ship1/Bullet1/D3/Pre1; */
      r[70] = r[215];          /* Plant1/Ship1/Bullet1/D4/pre_o = Plant1/Ship1/Bullet1/D4/Pre1; */
      r[72] = r[216];          /* Plant1/Ship1/Bullet1/Integral1/pre_o2 = Plant1/Ship1/Bullet1/Integral1/Pre1; */
      r[77] = r[217];          /* Plant1/Ship1/Bullet1/Integral2/pre_o2 = Plant1/Ship1/Bullet1/Integral2/Pre1; */
      b[13] = b[100];          /* Plant1/Ship1/pre_unfire = Plant1/Ship1/Pre1; */
      r[92] = r[218];          /* Plant1/Ship2/Rotation1/Integral1/pre_o = Plant1/Ship2/Rotation1/Integral1/Pre1; */
      r[109] = r[219];         /* Plant1/Ship2/Position1/Integral2/pre_o = Plant1/Ship2/Position1/Integral2/Pre1; */
      r[112] = r[220];         /* Plant1/Ship2/Position1/Integral4/pre_o = Plant1/Ship2/Position1/Integral4/Pre1; */
      b[60] = b[101];          /* Plant1/Ship2/Position1/SpeedX/PositiveEdge1/Pre2_o_1 = Plant1/Ship2/Position1/SpeedX/PositiveEdge1/Pre2; */
      r[108] = r[221];         /* Plant1/Ship2/Position1/sx = Plant1/Ship2/Position1/SpeedX/Pre3; */
      b[63] = b[102];          /* Plant1/Ship2/Position1/SpeedY/PositiveEdge1/Pre2_o_1 = Plant1/Ship2/Position1/SpeedY/PositiveEdge1/Pre2; */
      r[107] = r[222];         /* Plant1/Ship2/Position1/sy = Plant1/Ship2/Position1/SpeedY/Pre3; */
      b[72] = b[103];          /* Plant1/Ship2/Bullet1/SetReset1/PositiveEdge1/Pre2_o_1 = Plant1/Ship2/Bullet1/SetReset1/PositiveEdge1/Pre2; */
      b[74] = b[104];          /* Plant1/Ship2/Bullet1/SetReset1/PositiveEdge2/Pre2_o_1 = Plant1/Ship2/Bullet1/SetReset1/PositiveEdge2/Pre2; */
      b[67] = b[105];          /* Plant1/Ship2/Bullet1/SetReset1/pre = Plant1/Ship2/Bullet1/SetReset1/Pre1; */
      b[76] = b[106];          /* Plant1/Ship2/Bullet1/PositiveEdge1/Pre2_o_1 = Plant1/Ship2/Bullet1/PositiveEdge1/Pre2; */
      r[140] = r[223];         /* Plant1/Ship2/Bullet1/D1/pre_o = Plant1/Ship2/Bullet1/D1/Pre1; */
      r[141] = r[224];         /* Plant1/Ship2/Bullet1/D2/pre_o = Plant1/Ship2/Bullet1/D2/Pre1; */
      r[142] = r[225];         /* Plant1/Ship2/Bullet1/D3/pre_o = Plant1/Ship2/Bullet1/D3/Pre1; */
      r[143] = r[226];         /* Plant1/Ship2/Bullet1/D4/pre_o = Plant1/Ship2/Bullet1/D4/Pre1; */
      r[145] = r[227];         /* Plant1/Ship2/Bullet1/Integral1/pre_o2 = Plant1/Ship2/Bullet1/Integral1/Pre1; */
      r[150] = r[228];         /* Plant1/Ship2/Bullet1/Integral2/pre_o2 = Plant1/Ship2/Bullet1/Integral2/Pre1; */
      b[48] = b[107];          /* Plant1/Ship2/pre_unfire = Plant1/Ship2/Pre1; */
      i[3] = i[8];             /* Plant1/Hit1On2/Count2/pre = Plant1/Hit1On2/Count2/Pre1; */
      i[6] = i[9];             /* Plant1/Hit2On1/Count2/pre = Plant1/Hit2On1/Count2/Pre1; */
      b[8] = b[108];           /* MyAI1_left_1 = MyAI1/Pre1; */
      b[9] = b[109];           /* MyAI1_right_1 = MyAI1/Pre2; */
      r[194] = r[229];         /* MyAI1/AIThrust1/Derivative1/pre_i = MyAI1/AIThrust1/Derivative1/Pre1; */
      r[44] = 640f;            /* Plant1/Ship1/Position1/OutsideScreen1/width = 640f; */
      r[45] = 480f;            /* Plant1/Ship1/Position1/OutsideScreen1/height = 480f; */
      r[46] = -1f * r[35];     /* Plant1/Ship1/Position1/SpeedX/negative = -1f * Plant1/Ship1/Position1/sx; */
      b[24] = !b[25];          /* Plant1/Ship1/Position1/SpeedX/PositiveEdge1/Not1_o_1 = !Plant1/Ship1/Position1/SpeedX/PositiveEdge1/Pre2_o_1; */
      r[48] = 0.05f;           /* Plant1/Ship1/Position1/SpeedX/dt = 0.05f; */
      r[51] = -1f * r[34];     /* Plant1/Ship1/Position1/SpeedY/negative = -1f * Plant1/Ship1/Position1/sy; */
      b[27] = !b[28];          /* Plant1/Ship1/Position1/SpeedY/PositiveEdge1/Not1_o_1 = !Plant1/Ship1/Position1/SpeedY/PositiveEdge1/Pre2_o_1; */
      b[7] = b[0];             /* thrust1 = thrust; */
      r[53] = 0.05f;           /* Plant1/Ship1/Position1/SpeedY/dt = 0.05f; */
      b[36] = !b[37];          /* Plant1/Ship1/Bullet1/SetReset1/PositiveEdge1/Not1_o_1 = !Plant1/Ship1/Bullet1/SetReset1/PositiveEdge1/Pre2_o_1; */
      b[38] = !b[39];          /* Plant1/Ship1/Bullet1/SetReset1/PositiveEdge2/Not1_o_1 = !Plant1/Ship1/Bullet1/SetReset1/PositiveEdge2/Pre2_o_1; */
      b[30] = true;            /* Plant1/Ship1/Bullet1/SetReset1/set_value = true; */
      r[21] = 0.05f;           /* Plant1/Ship1/Rotation1/Integral1/dt = 0.05f; */
      b[33] = false;           /* Plant1/Ship1/Bullet1/SetReset1/reset_value = false; */
      b[40] = !b[41];          /* Plant1/Ship1/Bullet1/PositiveEdge1/Not1_o_1 = !Plant1/Ship1/Bullet1/PositiveEdge1/Pre2_o_1; */
      r[17] = 1.57079632679f;  /* Plant1/Ship1/Rotation1/startrot = 1.57079632679f; */
      r[28] = (b[0] ? 1f : 0f);/* Plant1/Ship1/Position1/t = (thrust ? 1f : 0f); */
      r[71] = 0f;              /* Plant1/Ship1/Bullet1/Negation1/z = 0f; */
      r[22] = 0.3f;            /* Plant1/Ship1/Position1/gravitation = 0.3f; */
      r[74] = 0.05f;           /* Plant1/Ship1/Bullet1/Integral1/Dt1_o_1 = 0.05f; */
      r[76] = 0f;              /* Plant1/Ship1/Bullet1/Integral1/Value1_o_1 = 0f; */
      r[79] = 0.05f;           /* Plant1/Ship1/Bullet1/Integral2/Dt1_o_1 = 0.05f; */
      r[81] = 0f;              /* Plant1/Ship1/Bullet1/Integral2/Value1_o_1 = 0f; */
      r[82] = 0f;              /* Plant1/Ship1/OutsideScreen1/zero = 0f; */
      r[83] = 640f;            /* Plant1/Ship1/OutsideScreen1/width = 640f; */
      r[84] = 480f;            /* Plant1/Ship1/OutsideScreen1/height = 480f; */
      r[85] = (b[8] ? 1f : 0f);/* Plant1/Ship2/Rotation1/left1 = (MyAI1_left_1 ? 1f : 0f); */
      r[87] = (b[9] ? 1f : 0f);/* Plant1/Ship2/Rotation1/right1 = (MyAI1_right_1 ? 1f : 0f); */
      r[86] = -1f * r[85];     /* Plant1/Ship2/Rotation1/lk = -1f * Plant1/Ship2/Rotation1/left1; */
      r[88] = r[86] + r[87];   /* Plant1/Ship2/Rotation1/rotdir = Plant1/Ship2/Rotation1/lk + Plant1/Ship2/Rotation1/right1; */
      r[89] = -2f * r[88];     /* Plant1/Ship2/Rotation1/rotspeed = -2f * Plant1/Ship2/Rotation1/rotdir; */
      r[94] = 0.05f;           /* Plant1/Ship2/Rotation1/Integral1/dt = 0.05f; */
      r[90] = 1.57079632679f;  /* Plant1/Ship2/Rotation1/startrot = 1.57079632679f; */
      r[95] = 0.3f;            /* Plant1/Ship2/Position1/gravitation = 0.3f; */
      r[12] = (b[1] ? 1f : 0f);/* Plant1/Ship1/Rotation1/left1 = (left ? 1f : 0f); */
      r[111] = 0.05f;          /* Plant1/Ship2/Position1/Integral2/dt = 0.05f; */
      r[114] = 0.05f;          /* Plant1/Ship2/Position1/Integral4/dt = 0.05f; */
      r[102] = 380f;           /* Plant1/Ship2/Position1/starty = 380f; */
      r[115] = 0f;             /* Plant1/Ship2/Position1/Negation1/z = 0f; */
      r[116] = 0f;             /* Plant1/Ship2/Position1/OutsideScreen1/zero = 0f; */
      r[117] = 640f;           /* Plant1/Ship2/Position1/OutsideScreen1/width = 640f; */
      r[118] = 480f;           /* Plant1/Ship2/Position1/OutsideScreen1/height = 480f; */
      r[119] = -1f * r[108];   /* Plant1/Ship2/Position1/SpeedX/negative = -1f * Plant1/Ship2/Position1/sx; */
      b[59] = !b[60];          /* Plant1/Ship2/Position1/SpeedX/PositiveEdge1/Not1_o_1 = !Plant1/Ship2/Position1/SpeedX/PositiveEdge1/Pre2_o_1; */
      r[38] = 0.05f;           /* Plant1/Ship1/Position1/Integral2/dt = 0.05f; */
      r[121] = 0.05f;          /* Plant1/Ship2/Position1/SpeedX/dt = 0.05f; */
      r[124] = -1f * r[107];   /* Plant1/Ship2/Position1/SpeedY/negative = -1f * Plant1/Ship2/Position1/sy; */
      r[14] = (b[3] ? 1f : 0f);/* Plant1/Ship1/Rotation1/right1 = (right ? 1f : 0f); */
      b[62] = !b[63];          /* Plant1/Ship2/Position1/SpeedY/PositiveEdge1/Not1_o_1 = !Plant1/Ship2/Position1/SpeedY/PositiveEdge1/Pre2_o_1; */
      r[126] = 0.05f;          /* Plant1/Ship2/Position1/SpeedY/dt = 0.05f; */
      b[71] = !b[72];          /* Plant1/Ship2/Bullet1/SetReset1/PositiveEdge1/Not1_o_1 = !Plant1/Ship2/Bullet1/SetReset1/PositiveEdge1/Pre2_o_1; */
      r[41] = 0.05f;           /* Plant1/Ship1/Position1/Integral4/dt = 0.05f; */
      b[73] = !b[74];          /* Plant1/Ship2/Bullet1/SetReset1/PositiveEdge2/Not1_o_1 = !Plant1/Ship2/Bullet1/SetReset1/PositiveEdge2/Pre2_o_1; */
      b[65] = true;            /* Plant1/Ship2/Bullet1/SetReset1/set_value = true; */
      b[68] = false;           /* Plant1/Ship2/Bullet1/SetReset1/reset_value = false; */
      b[75] = !b[76];          /* Plant1/Ship2/Bullet1/PositiveEdge1/Not1_o_1 = !Plant1/Ship2/Bullet1/PositiveEdge1/Pre2_o_1; */
      r[27] = 20f * r[28];     /* Plant1/Ship1/Position1/thrust1 = 20f * Plant1/Ship1/Position1/t; */
      r[29] = 380f;            /* Plant1/Ship1/Position1/starty = 380f; */
      r[42] = 0f;              /* Plant1/Ship1/Position1/Negation1/z = 0f; */
      r[144] = 0f;             /* Plant1/Ship2/Bullet1/Negation1/z = 0f; */
      r[147] = 0.05f;          /* Plant1/Ship2/Bullet1/Integral1/Dt1_o_1 = 0.05f; */
      r[149] = 0f;             /* Plant1/Ship2/Bullet1/Integral1/Value1_o_1 = 0f; */
      r[152] = 0.05f;          /* Plant1/Ship2/Bullet1/Integral2/Dt1_o_1 = 0.05f; */
      r[154] = 0f;             /* Plant1/Ship2/Bullet1/Integral2/Value1_o_1 = 0f; */
      r[43] = 0f;              /* Plant1/Ship1/Position1/OutsideScreen1/zero = 0f; */
      r[155] = 0f;             /* Plant1/Ship2/OutsideScreen1/zero = 0f; */
      r[156] = 640f;           /* Plant1/Ship2/OutsideScreen1/width = 640f; */
      r[157] = 480f;           /* Plant1/Ship2/OutsideScreen1/height = 480f; */
      r[158] = 20f;            /* Plant1/Hit1On2/hit_radius = 20f; */
      i[4] = 1;                /* Plant1/Hit1On2/Count2/one = 1; */
      r[165] = 20f;            /* Plant1/Hit2On1/hit_radius = 20f; */
      i[7] = 1;                /* Plant1/Hit2On1/Count2/one = 1; */
      r[10] = 100f;            /* Plant1/startx = 100f; */
      r[11] = 540f;            /* Plant1/startx2 = 540f; */
      r[180] = 3.14159265358979f;/* MyAI1/AILeftRight1/NormalizeAngle1/pi = 3.14159265358979f; */
      r[181] = 2f * r[180];    /* MyAI1/AILeftRight1/NormalizeAngle1/piX2 = 2f * MyAI1/AILeftRight1/NormalizeAngle1/pi; */
      r[183] = 0f;             /* MyAI1/AILeftRight1/NormalizeAngle1/zero = 0f; */
      r[178] = 0.1f;           /* MyAI1/AILeftRight1/rotate_threshold = 0.1f; */
      r[187] = 0f;             /* MyAI1/AILeftRight1/Negation1/z = 0f; */
      r[190] = -80f;           /* MyAI1/AIThrust1/speed_threshold = -80f; */
      r[192] = 0f;             /* MyAI1/AIThrust1/Abs1/zero = 0f; */
      r[189] = 0.3f;           /* MyAI1/AIThrust1/angle_threshold = 0.3f; */
      r[196] = 0.05f;          /* MyAI1/AIThrust1/Derivative1/Dt1_o_1 = 0.05f; */
      r[200] = 0f;             /* MyAI1/AIFire1/Abs1/zero = 0f; */
      r[198] = 0.1f;           /* MyAI1/AIFire1/angle_threshold = 0.1f; */
      r[199] = 100f;           /* MyAI1/AIFire1/distance_threshold = 100f; */
      r[110] = r[107] * r[111];/* Plant1/Ship2/Position1/Integral2/idt = Plant1/Ship2/Position1/sy * Plant1/Ship2/Position1/Integral2/dt; */
      r[113] = r[108] * r[114];/* Plant1/Ship2/Position1/Integral4/idt = Plant1/Ship2/Position1/sx * Plant1/Ship2/Position1/Integral4/dt; */
      r[37] = r[34] * r[38];   /* Plant1/Ship1/Position1/Integral2/idt = Plant1/Ship1/Position1/sy * Plant1/Ship1/Position1/Integral2/dt; */
      r[40] = r[35] * r[41];   /* Plant1/Ship1/Position1/Integral4/idt = Plant1/Ship1/Position1/sx * Plant1/Ship1/Position1/Integral4/dt; */
      b[70] = b[48] && b[73];  /* Plant1/Ship2/Bullet1/SetReset1/reset_edge = Plant1/Ship2/pre_unfire && Plant1/Ship2/Bullet1/SetReset1/PositiveEdge2/Not1_o_1; */
      b[31] = b[2] && b[36];   /* Plant1/Ship1/Bullet1/SetReset1/set_edge = fire && Plant1/Ship1/Bullet1/SetReset1/PositiveEdge1/Not1_o_1; */
      i[2] = i[3] + i[4];      /* Plant1/Hit1On2/Count2/pre_plus_1 = Plant1/Hit1On2/Count2/pre + Plant1/Hit1On2/Count2/one; */
      i[5] = i[6] + i[7];      /* Plant1/Hit2On1/Count2/pre_plus_1 = Plant1/Hit2On1/Count2/pre + Plant1/Hit2On1/Count2/one; */
      b[35] = b[13] && b[38];  /* Plant1/Ship1/Bullet1/SetReset1/reset_edge = Plant1/Ship1/pre_unfire && Plant1/Ship1/Bullet1/SetReset1/PositiveEdge2/Not1_o_1; */
      r[13] = -1f * r[12];     /* Plant1/Ship1/Rotation1/lk = -1f * Plant1/Ship1/Rotation1/left1; */
      b[34] = b[31] ? b[30] : b[32];/* Plant1/Ship1/Bullet1/SetReset1/pre_or_set = Plant1/Ship1/Bullet1/SetReset1/set_edge ? Plant1/Ship1/Bullet1/SetReset1/set_value : Plant1/Ship1/Bullet1/SetReset1/pre; */
      b[4] = b[35] ? b[33] : b[34];/* bullet1 = Plant1/Ship1/Bullet1/SetReset1/reset_edge ? Plant1/Ship1/Bullet1/SetReset1/reset_value : Plant1/Ship1/Bullet1/SetReset1/pre_or_set; */
      r[179] = r[187] - r[178];/* MyAI1/AILeftRight1/neg_threshold = MyAI1/AILeftRight1/Negation1/z - MyAI1/AILeftRight1/rotate_threshold; */
      r[93] = r[89] * r[94];   /* Plant1/Ship2/Rotation1/Integral1/idt = Plant1/Ship2/Rotation1/rotspeed * Plant1/Ship2/Rotation1/Integral1/dt; */
      b[29] = b[4] && b[40];   /* Plant1/Ship1/Bullet1/true_fire = bullet1 && Plant1/Ship1/Bullet1/PositiveEdge1/Not1_o_1; */
      r[15] = r[13] + r[14];   /* Plant1/Ship1/Rotation1/rotdir = Plant1/Ship1/Rotation1/lk + Plant1/Ship1/Rotation1/right1; */
      r[25] = r[40] + r[39];   /* Plant1/Ship1/Position1/px = Plant1/Ship1/Position1/Integral4/idt + Plant1/Ship1/Position1/Integral4/pre_o; */
      r[1] = r[10] + r[25];    /* x1 = Plant1/startx + Plant1/Ship1/Position1/px; */
      b[18] = r[1] < r[43];    /* Plant1/Ship1/Position1/OutsideScreen1/x_low = x1 < Plant1/Ship1/Position1/OutsideScreen1/zero; */
      r[60] = b[29] ? r[1] : r[67];/* Plant1/Ship1/Bullet1/origin_x = Plant1/Ship1/Bullet1/true_fire ? x1 : Plant1/Ship1/Bullet1/D1/pre_o; */
      b[21] = r[1] > r[44];    /* Plant1/Ship1/Position1/OutsideScreen1/x_hi = x1 > Plant1/Ship1/Position1/OutsideScreen1/width; */
      r[99] = r[110] + r[109]; /* Plant1/Ship2/Position1/py = Plant1/Ship2/Position1/Integral2/idt + Plant1/Ship2/Position1/Integral2/pre_o; */
      r[26] = r[37] + r[36];   /* Plant1/Ship1/Position1/py = Plant1/Ship1/Position1/Integral2/idt + Plant1/Ship1/Position1/Integral2/pre_o; */
      r[98] = r[113] + r[112]; /* Plant1/Ship2/Position1/px = Plant1/Ship2/Position1/Integral4/idt + Plant1/Ship2/Position1/Integral4/pre_o; */
      r[16] = -2f * r[15];     /* Plant1/Ship1/Rotation1/rotspeed = -2f * Plant1/Ship1/Rotation1/rotdir; */
      b[16] = b[21] || b[18];  /* Plant1/Ship1/Position1/out_x = Plant1/Ship1/Position1/OutsideScreen1/x_hi || Plant1/Ship1/Position1/OutsideScreen1/x_low; */
      r[91] = r[93] + r[92];   /* Plant1/Ship2/Rotation1/rotrel = Plant1/Ship2/Rotation1/Integral1/idt + Plant1/Ship2/Rotation1/Integral1/pre_o; */
      r[4] = r[91] + r[90];    /* rot2 = Plant1/Ship2/Rotation1/rotrel + Plant1/Ship2/Rotation1/startrot; */
      r[3] = r[11] + r[98];    /* x2 = Plant1/startx2 + Plant1/Ship2/Position1/px; */
      r[202] = r[1] - r[3];    /* MyAI1/Distance1/dx = x1 - x2; */
      r[204] = r[202] * r[202];/* MyAI1/Distance1/Length1/dx2 = MyAI1/Distance1/dx * MyAI1/Distance1/dx; */
      r[7] = r[99] + r[102];   /* y2 = Plant1/Ship2/Position1/py + Plant1/Ship2/Position1/starty; */
      r[0] = r[26] + r[29];    /* y1 = Plant1/Ship1/Position1/py + Plant1/Ship1/Position1/starty; */
      r[129] = (float)Math.cos(r[4]);/* Plant1/Ship2/Bullet1/cos = (float)Math.cos(rot2); */
      r[134] = (float)Math.sin(r[4]);/* Plant1/Ship2/Bullet1/sin = (float)Math.sin(rot2); */
      r[135] = r[144] - r[134];/* Plant1/Ship2/Bullet1/negsin = Plant1/Ship2/Bullet1/Negation1/z - Plant1/Ship2/Bullet1/sin; */
      b[22] = r[0] < r[43];    /* Plant1/Ship1/Position1/OutsideScreen1/y_low = y1 < Plant1/Ship1/Position1/OutsideScreen1/zero; */
      r[20] = r[16] * r[21];   /* Plant1/Ship1/Rotation1/Integral1/idt = Plant1/Ship1/Rotation1/rotspeed * Plant1/Ship1/Rotation1/Integral1/dt; */
      b[53] = r[3] < r[116];   /* Plant1/Ship2/Position1/OutsideScreen1/x_low = x2 < Plant1/Ship2/Position1/OutsideScreen1/zero; */
      b[57] = r[7] < r[116];   /* Plant1/Ship2/Position1/OutsideScreen1/y_low = y2 < Plant1/Ship2/Position1/OutsideScreen1/zero; */
      b[19] = r[0] > r[45];    /* Plant1/Ship1/Position1/OutsideScreen1/y_hi = y1 > Plant1/Ship1/Position1/OutsideScreen1/height; */
      r[103] = (float)Math.sin(r[4]);/* Plant1/Ship2/Position1/sin = (float)Math.sin(rot2); */
      r[174] = r[1] - r[3];    /* MyAI1/AILeftRight1/dx = x1 - x2; */
      r[175] = r[7] - r[0];    /* MyAI1/AILeftRight1/dy = y2 - y1; */
      r[176] = (float)Math.atan2(r[175],r[174]);/* MyAI1/AILeftRight1/angle = (float)Math.atan2(MyAI1/AILeftRight1/dy,MyAI1/AILeftRight1/dx); */
      r[177] = r[176] - r[4];  /* MyAI1/AILeftRight1/angle_diff = MyAI1/AILeftRight1/angle - rot2; */
      r[182] = r[177] + r[180];/* MyAI1/AILeftRight1/NormalizeAngle1/i_plus_pi = MyAI1/AILeftRight1/angle_diff + MyAI1/AILeftRight1/NormalizeAngle1/pi; */
      b[23] = b[16] && b[24];  /* Plant1/Ship1/Position1/SpeedX/negate_edge = Plant1/Ship1/Position1/out_x && Plant1/Ship1/Position1/SpeedX/PositiveEdge1/Not1_o_1; */
      b[56] = r[3] > r[117];   /* Plant1/Ship2/Position1/OutsideScreen1/x_hi = x2 > Plant1/Ship2/Position1/OutsideScreen1/width; */
      r[96] = (float)Math.cos(r[4]);/* Plant1/Ship2/Position1/cos = (float)Math.cos(rot2); */
      b[54] = r[7] > r[118];   /* Plant1/Ship2/Position1/OutsideScreen1/y_hi = y2 > Plant1/Ship2/Position1/OutsideScreen1/height; */
      b[51] = b[56] || b[53];  /* Plant1/Ship2/Position1/out_x = Plant1/Ship2/Position1/OutsideScreen1/x_hi || Plant1/Ship2/Position1/OutsideScreen1/x_low; */
      r[59] = b[29] ? r[0] : r[68];/* Plant1/Ship1/Bullet1/origin_y = Plant1/Ship1/Bullet1/true_fire ? y1 : Plant1/Ship1/Bullet1/D2/pre_o; */
      b[17] = b[19] || b[22];  /* Plant1/Ship1/Position1/out_y = Plant1/Ship1/Position1/OutsideScreen1/y_hi || Plant1/Ship1/Position1/OutsideScreen1/y_low; */
      b[52] = b[54] || b[57];  /* Plant1/Ship2/Position1/out_y = Plant1/Ship2/Position1/OutsideScreen1/y_hi || Plant1/Ship2/Position1/OutsideScreen1/y_low; */
      r[203] = r[0] - r[7];    /* MyAI1/Distance1/dy = y1 - y2; */
      r[205] = r[203] * r[203];/* MyAI1/Distance1/Length1/dy2 = MyAI1/Distance1/dy * MyAI1/Distance1/dy; */
      r[206] = r[204] + r[205];/* MyAI1/Distance1/Length1/sum = MyAI1/Distance1/Length1/dx2 + MyAI1/Distance1/Length1/dy2; */
      r[173] = (float)Math.sqrt(r[206]);/* MyAI1/distance = (float)Math.sqrt(MyAI1/Distance1/Length1/sum); */
      b[26] = b[17] && b[27];  /* Plant1/Ship1/Position1/SpeedY/negate_edge = Plant1/Ship1/Position1/out_y && Plant1/Ship1/Position1/SpeedY/PositiveEdge1/Not1_o_1; */
      r[18] = r[20] + r[19];   /* Plant1/Ship1/Rotation1/rotrel = Plant1/Ship1/Rotation1/Integral1/idt + Plant1/Ship1/Rotation1/Integral1/pre_o; */
      b[58] = b[51] && b[59];  /* Plant1/Ship2/Position1/SpeedX/negate_edge = Plant1/Ship2/Position1/out_x && Plant1/Ship2/Position1/SpeedX/PositiveEdge1/Not1_o_1; */
      r[104] = r[115] - r[103];/* Plant1/Ship2/Position1/negsin = Plant1/Ship2/Position1/Negation1/z - Plant1/Ship2/Position1/sin; */
      b[61] = b[52] && b[62];  /* Plant1/Ship2/Position1/SpeedY/negate_edge = Plant1/Ship2/Position1/out_y && Plant1/Ship2/Position1/SpeedY/PositiveEdge1/Not1_o_1; */
      r[184] = r[182] % r[181];/* MyAI1/AILeftRight1/NormalizeAngle1/modulus = MyAI1/AILeftRight1/NormalizeAngle1/i_plus_pi % MyAI1/AILeftRight1/NormalizeAngle1/piX2; */
      b[87] = r[184] < r[183]; /* MyAI1/AILeftRight1/NormalizeAngle1/negative = MyAI1/AILeftRight1/NormalizeAngle1/modulus < MyAI1/AILeftRight1/NormalizeAngle1/zero; */
      r[185] = r[184] + r[181];/* MyAI1/AILeftRight1/NormalizeAngle1/modulus_plus_pi = MyAI1/AILeftRight1/NormalizeAngle1/modulus + MyAI1/AILeftRight1/NormalizeAngle1/piX2; */
      b[20] = b[17] || b[16];  /* Plant1/Ship1/Position1/OutsideScreen1/outside = Plant1/Ship1/Position1/out_y || Plant1/Ship1/Position1/out_x; */
      b[55] = b[52] || b[51];  /* Plant1/Ship2/Position1/OutsideScreen1/outside = Plant1/Ship2/Position1/out_y || Plant1/Ship2/Position1/out_x; */
      r[195] = r[173] - r[194];/* MyAI1/AIThrust1/Derivative1/diff = MyAI1/distance - MyAI1/AIThrust1/Derivative1/pre_i; */
      r[191] = r[195] / r[196];/* MyAI1/AIThrust1/speed = MyAI1/AIThrust1/Derivative1/diff / MyAI1/AIThrust1/Derivative1/Dt1_o_1; */
      r[2] = r[18] + r[17];    /* rot1 = Plant1/Ship1/Rotation1/rotrel + Plant1/Ship1/Rotation1/startrot; */
      b[89] = r[191] > r[190]; /* MyAI1/AIThrust1/speed_thrust = MyAI1/AIThrust1/speed > MyAI1/AIThrust1/speed_threshold; */
      b[92] = r[173] < r[199]; /* MyAI1/AIFire1/distance_fire = MyAI1/distance < MyAI1/AIFire1/distance_threshold; */
      r[30] = (float)Math.sin(r[2]);/* Plant1/Ship1/Position1/sin = (float)Math.sin(rot1); */
      r[56] = (float)Math.cos(r[2]);/* Plant1/Ship1/Bullet1/cos = (float)Math.cos(rot1); */
      r[61] = (float)Math.sin(r[2]);/* Plant1/Ship1/Bullet1/sin = (float)Math.sin(rot1); */
      r[186] = b[87] ? r[185] : r[184];/* MyAI1/AILeftRight1/NormalizeAngle1/zero_to_piX2 = MyAI1/AILeftRight1/NormalizeAngle1/negative ? MyAI1/AILeftRight1/NormalizeAngle1/modulus_plus_pi : MyAI1/AILeftRight1/NormalizeAngle1/modulus; */
      r[23] = (float)Math.cos(r[2]);/* Plant1/Ship1/Position1/cos = (float)Math.cos(rot1); */
      r[31] = r[42] - r[30];   /* Plant1/Ship1/Position1/negsin = Plant1/Ship1/Position1/Negation1/z - Plant1/Ship1/Position1/sin; */
      r[57] = b[29] ? r[56] : r[69];/* Plant1/Ship1/Bullet1/dir_x = Plant1/Ship1/Bullet1/true_fire ? Plant1/Ship1/Bullet1/cos : Plant1/Ship1/Bullet1/D3/pre_o; */
      r[32] = r[23] * r[27];   /* Plant1/Ship1/Position1/accx = Plant1/Ship1/Position1/cos * Plant1/Ship1/Position1/thrust1; */
      r[62] = r[71] - r[61];   /* Plant1/Ship1/Bullet1/negsin = Plant1/Ship1/Bullet1/Negation1/z - Plant1/Ship1/Bullet1/sin; */
      r[63] = 150f * r[57];    /* Plant1/Ship1/Bullet1/speed_x = 150f * Plant1/Ship1/Bullet1/dir_x; */
      r[172] = r[186] - r[180];/* MyAI1/angle_diff = MyAI1/AILeftRight1/NormalizeAngle1/zero_to_piX2 - MyAI1/AILeftRight1/NormalizeAngle1/pi; */
      b[86] = r[172] < r[179]; /* MyAI1/right1 = MyAI1/angle_diff < MyAI1/AILeftRight1/neg_threshold; */
      b[85] = r[172] > r[178]; /* MyAI1/left1 = MyAI1/angle_diff > MyAI1/AILeftRight1/rotate_threshold; */
      r[24] = r[31] * r[27];   /* Plant1/Ship1/Position1/accy = Plant1/Ship1/Position1/negsin * Plant1/Ship1/Position1/thrust1; */
      b[90] = r[172] < r[192]; /* MyAI1/AIThrust1/Abs1/is_negative = MyAI1/angle_diff < MyAI1/AIThrust1/Abs1/zero; */
      r[193] = r[192] - r[172];/* MyAI1/AIThrust1/Abs1/negative = MyAI1/AIThrust1/Abs1/zero - MyAI1/angle_diff; */
      r[188] = b[90] ? r[193] : r[172];/* MyAI1/AIThrust1/abs_diff = MyAI1/AIThrust1/Abs1/is_negative ? MyAI1/AIThrust1/Abs1/negative : MyAI1/angle_diff; */
      b[88] = r[188] < r[189]; /* MyAI1/AIThrust1/angle_thrust = MyAI1/AIThrust1/abs_diff < MyAI1/AIThrust1/angle_threshold; */
      b[6] = b[88] && b[89];   /* thrust2 = MyAI1/AIThrust1/angle_thrust && MyAI1/AIThrust1/speed_thrust; */
      r[73] = r[63] * r[74];   /* Plant1/Ship1/Bullet1/Integral1/Mult1_o_1 = Plant1/Ship1/Bullet1/speed_x * Plant1/Ship1/Bullet1/Integral1/Dt1_o_1; */
      b[93] = r[172] < r[200]; /* MyAI1/AIFire1/Abs1/is_negative = MyAI1/angle_diff < MyAI1/AIFire1/Abs1/zero; */
      r[201] = r[200] - r[172];/* MyAI1/AIFire1/Abs1/negative = MyAI1/AIFire1/Abs1/zero - MyAI1/angle_diff; */
      r[197] = b[93] ? r[201] : r[172];/* MyAI1/AIFire1/abs_diff = MyAI1/AIFire1/Abs1/is_negative ? MyAI1/AIFire1/Abs1/negative : MyAI1/angle_diff; */
      b[91] = r[197] < r[198]; /* MyAI1/AIFire1/angle_fire = MyAI1/AIFire1/abs_diff < MyAI1/AIFire1/angle_threshold; */
      b[10] = b[91] && b[92];  /* MyAI1_fire_1 = MyAI1/AIFire1/angle_fire && MyAI1/AIFire1/distance_fire; */
      r[101] = (b[6] ? 1f : 0f);/* Plant1/Ship2/Position1/t = (thrust2 ? 1f : 0f); */
      r[58] = b[29] ? r[62] : r[70];/* Plant1/Ship1/Bullet1/dir_y = Plant1/Ship1/Bullet1/true_fire ? Plant1/Ship1/Bullet1/negsin : Plant1/Ship1/Bullet1/D4/pre_o; */
      r[65] = 150f * r[58];    /* Plant1/Ship1/Bullet1/speed_y = 150f * Plant1/Ship1/Bullet1/dir_y; */
      r[33] = r[24] + r[22];   /* Plant1/Ship1/Position1/ay = Plant1/Ship1/Position1/accy + Plant1/Ship1/Position1/gravitation; */
      r[100] = 20f * r[101];   /* Plant1/Ship2/Position1/thrust1 = 20f * Plant1/Ship2/Position1/t; */
      r[47] = r[32] * r[48];   /* Plant1/Ship1/Position1/SpeedX/m = Plant1/Ship1/Position1/accx * Plant1/Ship1/Position1/SpeedX/dt; */
      r[97] = r[104] * r[100]; /* Plant1/Ship2/Position1/accy = Plant1/Ship2/Position1/negsin * Plant1/Ship2/Position1/thrust1; */
      r[106] = r[97] + r[95];  /* Plant1/Ship2/Position1/ay = Plant1/Ship2/Position1/accy + Plant1/Ship2/Position1/gravitation; */
      b[66] = b[10] && b[71];  /* Plant1/Ship2/Bullet1/SetReset1/set_edge = MyAI1_fire_1 && Plant1/Ship2/Bullet1/SetReset1/PositiveEdge1/Not1_o_1; */
      r[52] = r[33] * r[53];   /* Plant1/Ship1/Position1/SpeedY/m = Plant1/Ship1/Position1/ay * Plant1/Ship1/Position1/SpeedY/dt; */
      r[75] = r[73] + r[72];   /* Plant1/Ship1/Bullet1/Integral1/o1 = Plant1/Ship1/Bullet1/Integral1/Mult1_o_1 + Plant1/Ship1/Bullet1/Integral1/pre_o2; */
      r[105] = r[96] * r[100]; /* Plant1/Ship2/Position1/accx = Plant1/Ship2/Position1/cos * Plant1/Ship2/Position1/thrust1; */
      r[120] = r[105] * r[121];/* Plant1/Ship2/Position1/SpeedX/m = Plant1/Ship2/Position1/accx * Plant1/Ship2/Position1/SpeedX/dt; */
      r[78] = r[65] * r[79];   /* Plant1/Ship1/Bullet1/Integral2/Mult1_o_1 = Plant1/Ship1/Bullet1/speed_y * Plant1/Ship1/Bullet1/Integral2/Dt1_o_1; */
      b[69] = b[66] ? b[65] : b[67];/* Plant1/Ship2/Bullet1/SetReset1/pre_or_set = Plant1/Ship2/Bullet1/SetReset1/set_edge ? Plant1/Ship2/Bullet1/SetReset1/set_value : Plant1/Ship2/Bullet1/SetReset1/pre; */
      r[49] = r[47] + r[35];   /* Plant1/Ship1/Position1/SpeedX/a = Plant1/Ship1/Position1/SpeedX/m + Plant1/Ship1/Position1/sx; */
      b[5] = b[70] ? b[68] : b[69];/* bullet2 = Plant1/Ship2/Bullet1/SetReset1/reset_edge ? Plant1/Ship2/Bullet1/SetReset1/reset_value : Plant1/Ship2/Bullet1/SetReset1/pre_or_set; */
      r[64] = b[29] ? r[76] : r[75];/* Plant1/Ship1/Bullet1/relx = Plant1/Ship1/Bullet1/true_fire ? Plant1/Ship1/Bullet1/Integral1/Value1_o_1 : Plant1/Ship1/Bullet1/Integral1/o1; */
      r[5] = r[60] + r[64];    /* bulletx1 = Plant1/Ship1/Bullet1/origin_x + Plant1/Ship1/Bullet1/relx; */
      r[50] = b[23] ? r[46] : r[49];/* Plant1/Ship1/Position1/SpeedX/If1_o_1 = Plant1/Ship1/Position1/SpeedX/negate_edge ? Plant1/Ship1/Position1/SpeedX/negative : Plant1/Ship1/Position1/SpeedX/a; */
      r[160] = r[5] - r[3];    /* Plant1/Hit1On2/Distance1/dx = bulletx1 - x2; */
      r[162] = r[160] * r[160];/* Plant1/Hit1On2/Distance1/Length1/dx2 = Plant1/Hit1On2/Distance1/dx * Plant1/Hit1On2/Distance1/dx; */
      r[122] = r[120] + r[108];/* Plant1/Ship2/Position1/SpeedX/a = Plant1/Ship2/Position1/SpeedX/m + Plant1/Ship2/Position1/sx; */
      r[125] = r[106] * r[126];/* Plant1/Ship2/Position1/SpeedY/m = Plant1/Ship2/Position1/ay * Plant1/Ship2/Position1/SpeedY/dt; */
      r[80] = r[78] + r[77];   /* Plant1/Ship1/Bullet1/Integral2/o1 = Plant1/Ship1/Bullet1/Integral2/Mult1_o_1 + Plant1/Ship1/Bullet1/Integral2/pre_o2; */
      r[54] = r[52] + r[34];   /* Plant1/Ship1/Position1/SpeedY/a = Plant1/Ship1/Position1/SpeedY/m + Plant1/Ship1/Position1/sy; */
      b[64] = b[5] && b[75];   /* Plant1/Ship2/Bullet1/true_fire = bullet2 && Plant1/Ship2/Bullet1/PositiveEdge1/Not1_o_1; */
      r[133] = b[64] ? r[3] : r[140];/* Plant1/Ship2/Bullet1/origin_x = Plant1/Ship2/Bullet1/true_fire ? x2 : Plant1/Ship2/Bullet1/D1/pre_o; */
      r[66] = b[29] ? r[81] : r[80];/* Plant1/Ship1/Bullet1/rely = Plant1/Ship1/Bullet1/true_fire ? Plant1/Ship1/Bullet1/Integral2/Value1_o_1 : Plant1/Ship1/Bullet1/Integral2/o1; */
      r[130] = b[64] ? r[129] : r[142];/* Plant1/Ship2/Bullet1/dir_x = Plant1/Ship2/Bullet1/true_fire ? Plant1/Ship2/Bullet1/cos : Plant1/Ship2/Bullet1/D3/pre_o; */
      b[42] = r[5] < r[82];    /* Plant1/Ship1/OutsideScreen1/x_low = bulletx1 < Plant1/Ship1/OutsideScreen1/zero; */
      r[131] = b[64] ? r[135] : r[143];/* Plant1/Ship2/Bullet1/dir_y = Plant1/Ship2/Bullet1/true_fire ? Plant1/Ship2/Bullet1/negsin : Plant1/Ship2/Bullet1/D4/pre_o; */
      r[136] = 150f * r[130];  /* Plant1/Ship2/Bullet1/speed_x = 150f * Plant1/Ship2/Bullet1/dir_x; */
      r[146] = r[136] * r[147];/* Plant1/Ship2/Bullet1/Integral1/Mult1_o_1 = Plant1/Ship2/Bullet1/speed_x * Plant1/Ship2/Bullet1/Integral1/Dt1_o_1; */
      b[46] = r[5] > r[83];    /* Plant1/Ship1/OutsideScreen1/x_hi = bulletx1 > Plant1/Ship1/OutsideScreen1/width; */
      r[138] = 150f * r[131];  /* Plant1/Ship2/Bullet1/speed_y = 150f * Plant1/Ship2/Bullet1/dir_y; */
      r[123] = b[58] ? r[119] : r[122];/* Plant1/Ship2/Position1/SpeedX/If1_o_1 = Plant1/Ship2/Position1/SpeedX/negate_edge ? Plant1/Ship2/Position1/SpeedX/negative : Plant1/Ship2/Position1/SpeedX/a; */
      r[55] = b[26] ? r[51] : r[54];/* Plant1/Ship1/Position1/SpeedY/If1_o_1 = Plant1/Ship1/Position1/SpeedY/negate_edge ? Plant1/Ship1/Position1/SpeedY/negative : Plant1/Ship1/Position1/SpeedY/a; */
      r[151] = r[138] * r[152];/* Plant1/Ship2/Bullet1/Integral2/Mult1_o_1 = Plant1/Ship2/Bullet1/speed_y * Plant1/Ship2/Bullet1/Integral2/Dt1_o_1; */
      b[43] = b[46] || b[42];  /* Plant1/Ship1/OutsideScreen1/x_outside = Plant1/Ship1/OutsideScreen1/x_hi || Plant1/Ship1/OutsideScreen1/x_low; */
      r[6] = r[59] + r[66];    /* bullety1 = Plant1/Ship1/Bullet1/origin_y + Plant1/Ship1/Bullet1/rely; */
      b[47] = r[6] < r[82];    /* Plant1/Ship1/OutsideScreen1/y_low = bullety1 < Plant1/Ship1/OutsideScreen1/zero; */
      r[148] = r[146] + r[145];/* Plant1/Ship2/Bullet1/Integral1/o1 = Plant1/Ship2/Bullet1/Integral1/Mult1_o_1 + Plant1/Ship2/Bullet1/Integral1/pre_o2; */
      r[137] = b[64] ? r[149] : r[148];/* Plant1/Ship2/Bullet1/relx = Plant1/Ship2/Bullet1/true_fire ? Plant1/Ship2/Bullet1/Integral1/Value1_o_1 : Plant1/Ship2/Bullet1/Integral1/o1; */
      r[161] = r[6] - r[7];    /* Plant1/Hit1On2/Distance1/dy = bullety1 - y2; */
      r[127] = r[125] + r[107];/* Plant1/Ship2/Position1/SpeedY/a = Plant1/Ship2/Position1/SpeedY/m + Plant1/Ship2/Position1/sy; */
      r[132] = b[64] ? r[7] : r[141];/* Plant1/Ship2/Bullet1/origin_y = Plant1/Ship2/Bullet1/true_fire ? y2 : Plant1/Ship2/Bullet1/D2/pre_o; */
      r[8] = r[133] + r[137];  /* bulletx2 = Plant1/Ship2/Bullet1/origin_x + Plant1/Ship2/Bullet1/relx; */
      b[44] = r[6] > r[84];    /* Plant1/Ship1/OutsideScreen1/y_hi = bullety1 > Plant1/Ship1/OutsideScreen1/height; */
      r[167] = r[8] - r[1];    /* Plant1/Hit2On1/Distance1/dx = bulletx2 - x1; */
      r[128] = b[61] ? r[124] : r[127];/* Plant1/Ship2/Position1/SpeedY/If1_o_1 = Plant1/Ship2/Position1/SpeedY/negate_edge ? Plant1/Ship2/Position1/SpeedY/negative : Plant1/Ship2/Position1/SpeedY/a; */
      b[77] = r[8] < r[155];   /* Plant1/Ship2/OutsideScreen1/x_low = bulletx2 < Plant1/Ship2/OutsideScreen1/zero; */
      r[163] = r[161] * r[161];/* Plant1/Hit1On2/Distance1/Length1/dy2 = Plant1/Hit1On2/Distance1/dy * Plant1/Hit1On2/Distance1/dy; */
      r[169] = r[167] * r[167];/* Plant1/Hit2On1/Distance1/Length1/dx2 = Plant1/Hit2On1/Distance1/dx * Plant1/Hit2On1/Distance1/dx; */
      b[81] = r[8] > r[156];   /* Plant1/Ship2/OutsideScreen1/x_hi = bulletx2 > Plant1/Ship2/OutsideScreen1/width; */
      b[78] = b[81] || b[77];  /* Plant1/Ship2/OutsideScreen1/x_outside = Plant1/Ship2/OutsideScreen1/x_hi || Plant1/Ship2/OutsideScreen1/x_low; */
      r[153] = r[151] + r[150];/* Plant1/Ship2/Bullet1/Integral2/o1 = Plant1/Ship2/Bullet1/Integral2/Mult1_o_1 + Plant1/Ship2/Bullet1/Integral2/pre_o2; */
      r[164] = r[162] + r[163];/* Plant1/Hit1On2/Distance1/Length1/sum = Plant1/Hit1On2/Distance1/Length1/dx2 + Plant1/Hit1On2/Distance1/Length1/dy2; */
      r[159] = (float)Math.sqrt(r[164]);/* Plant1/Hit1On2/distance = (float)Math.sqrt(Plant1/Hit1On2/Distance1/Length1/sum); */
      b[83] = r[159] < r[158]; /* Plant1/Hit1On2/inside_radius = Plant1/Hit1On2/distance < Plant1/Hit1On2/hit_radius; */
      b[45] = b[44] || b[47];  /* Plant1/Ship1/OutsideScreen1/y_outside = Plant1/Ship1/OutsideScreen1/y_hi || Plant1/Ship1/OutsideScreen1/y_low; */
      b[11] = b[4] && b[83];   /* Plant1/hit1on2 = bullet1 && Plant1/Hit1On2/inside_radius; */
      b[15] = b[45] || b[43];  /* Plant1/Ship1/outside_screen = Plant1/Ship1/OutsideScreen1/y_outside || Plant1/Ship1/OutsideScreen1/x_outside; */
      r[139] = b[64] ? r[154] : r[153];/* Plant1/Ship2/Bullet1/rely = Plant1/Ship2/Bullet1/true_fire ? Plant1/Ship2/Bullet1/Integral2/Value1_o_1 : Plant1/Ship2/Bullet1/Integral2/o1; */
      b[14] = b[15] || b[11];  /* Plant1/Ship1/unfire = Plant1/Ship1/outside_screen || Plant1/hit1on2; */
      i[0] = b[11] ? i[2] : i[3];/* hits1on2 = Plant1/hit1on2 ? Plant1/Hit1On2/Count2/pre_plus_1 : Plant1/Hit1On2/Count2/pre; */
      r[9] = r[132] + r[139];  /* bullety2 = Plant1/Ship2/Bullet1/origin_y + Plant1/Ship2/Bullet1/rely; */
      r[168] = r[9] - r[0];    /* Plant1/Hit2On1/Distance1/dy = bullety2 - y1; */
      b[82] = r[9] < r[155];   /* Plant1/Ship2/OutsideScreen1/y_low = bullety2 < Plant1/Ship2/OutsideScreen1/zero; */
      b[79] = r[9] > r[157];   /* Plant1/Ship2/OutsideScreen1/y_hi = bullety2 > Plant1/Ship2/OutsideScreen1/height; */
      r[170] = r[168] * r[168];/* Plant1/Hit2On1/Distance1/Length1/dy2 = Plant1/Hit2On1/Distance1/dy * Plant1/Hit2On1/Distance1/dy; */
      r[171] = r[169] + r[170];/* Plant1/Hit2On1/Distance1/Length1/sum = Plant1/Hit2On1/Distance1/Length1/dx2 + Plant1/Hit2On1/Distance1/Length1/dy2; */
      r[166] = (float)Math.sqrt(r[171]);/* Plant1/Hit2On1/distance = (float)Math.sqrt(Plant1/Hit2On1/Distance1/Length1/sum); */
      b[80] = b[79] || b[82];  /* Plant1/Ship2/OutsideScreen1/y_outside = Plant1/Ship2/OutsideScreen1/y_hi || Plant1/Ship2/OutsideScreen1/y_low; */
      b[84] = r[166] < r[165]; /* Plant1/Hit2On1/inside_radius = Plant1/Hit2On1/distance < Plant1/Hit2On1/hit_radius; */
      b[12] = b[5] && b[84];   /* Plant1/hit2on1 = bullet2 && Plant1/Hit2On1/inside_radius; */
      b[50] = b[80] || b[78];  /* Plant1/Ship2/outside_screen = Plant1/Ship2/OutsideScreen1/y_outside || Plant1/Ship2/OutsideScreen1/x_outside; */
      i[1] = b[12] ? i[5] : i[6];/* hits2on1 = Plant1/hit2on1 ? Plant1/Hit2On1/Count2/pre_plus_1 : Plant1/Hit2On1/Count2/pre; */
      b[49] = b[50] || b[12];  /* Plant1/Ship2/unfire = Plant1/Ship2/outside_screen || Plant1/hit2on1; */

      // State update equations
      r[207] = r[18];          /* Plant1/Ship1/Rotation1/Integral1/Pre1 = Plant1/Ship1/Rotation1/rotrel; */
      r[208] = r[26];          /* Plant1/Ship1/Position1/Integral2/Pre1 = Plant1/Ship1/Position1/py; */
      r[209] = r[25];          /* Plant1/Ship1/Position1/Integral4/Pre1 = Plant1/Ship1/Position1/px; */
      b[94] = b[16];           /* Plant1/Ship1/Position1/SpeedX/PositiveEdge1/Pre2 = Plant1/Ship1/Position1/out_x; */
      r[210] = r[50];          /* Plant1/Ship1/Position1/SpeedX/Pre3 = Plant1/Ship1/Position1/SpeedX/If1_o_1; */
      b[95] = b[17];           /* Plant1/Ship1/Position1/SpeedY/PositiveEdge1/Pre2 = Plant1/Ship1/Position1/out_y; */
      r[211] = r[55];          /* Plant1/Ship1/Position1/SpeedY/Pre3 = Plant1/Ship1/Position1/SpeedY/If1_o_1; */
      b[96] = b[2];            /* Plant1/Ship1/Bullet1/SetReset1/PositiveEdge1/Pre2 = fire; */
      b[97] = b[13];           /* Plant1/Ship1/Bullet1/SetReset1/PositiveEdge2/Pre2 = Plant1/Ship1/pre_unfire; */
      b[98] = b[4];            /* Plant1/Ship1/Bullet1/SetReset1/Pre1 = bullet1; */
      b[99] = b[4];            /* Plant1/Ship1/Bullet1/PositiveEdge1/Pre2 = bullet1; */
      r[212] = r[60];          /* Plant1/Ship1/Bullet1/D1/Pre1 = Plant1/Ship1/Bullet1/origin_x; */
      r[213] = r[59];          /* Plant1/Ship1/Bullet1/D2/Pre1 = Plant1/Ship1/Bullet1/origin_y; */
      r[214] = r[57];          /* Plant1/Ship1/Bullet1/D3/Pre1 = Plant1/Ship1/Bullet1/dir_x; */
      r[215] = r[58];          /* Plant1/Ship1/Bullet1/D4/Pre1 = Plant1/Ship1/Bullet1/dir_y; */
      r[216] = r[64];          /* Plant1/Ship1/Bullet1/Integral1/Pre1 = Plant1/Ship1/Bullet1/relx; */
      r[217] = r[66];          /* Plant1/Ship1/Bullet1/Integral2/Pre1 = Plant1/Ship1/Bullet1/rely; */
      b[100] = b[14];          /* Plant1/Ship1/Pre1 = Plant1/Ship1/unfire; */
      r[218] = r[91];          /* Plant1/Ship2/Rotation1/Integral1/Pre1 = Plant1/Ship2/Rotation1/rotrel; */
      r[219] = r[99];          /* Plant1/Ship2/Position1/Integral2/Pre1 = Plant1/Ship2/Position1/py; */
      r[220] = r[98];          /* Plant1/Ship2/Position1/Integral4/Pre1 = Plant1/Ship2/Position1/px; */
      b[101] = b[51];          /* Plant1/Ship2/Position1/SpeedX/PositiveEdge1/Pre2 = Plant1/Ship2/Position1/out_x; */
      r[221] = r[123];         /* Plant1/Ship2/Position1/SpeedX/Pre3 = Plant1/Ship2/Position1/SpeedX/If1_o_1; */
      b[102] = b[52];          /* Plant1/Ship2/Position1/SpeedY/PositiveEdge1/Pre2 = Plant1/Ship2/Position1/out_y; */
      r[222] = r[128];         /* Plant1/Ship2/Position1/SpeedY/Pre3 = Plant1/Ship2/Position1/SpeedY/If1_o_1; */
      b[103] = b[10];          /* Plant1/Ship2/Bullet1/SetReset1/PositiveEdge1/Pre2 = MyAI1_fire_1; */
      b[104] = b[48];          /* Plant1/Ship2/Bullet1/SetReset1/PositiveEdge2/Pre2 = Plant1/Ship2/pre_unfire; */
      b[105] = b[5];           /* Plant1/Ship2/Bullet1/SetReset1/Pre1 = bullet2; */
      b[106] = b[5];           /* Plant1/Ship2/Bullet1/PositiveEdge1/Pre2 = bullet2; */
      r[223] = r[133];         /* Plant1/Ship2/Bullet1/D1/Pre1 = Plant1/Ship2/Bullet1/origin_x; */
      r[224] = r[132];         /* Plant1/Ship2/Bullet1/D2/Pre1 = Plant1/Ship2/Bullet1/origin_y; */
      r[225] = r[130];         /* Plant1/Ship2/Bullet1/D3/Pre1 = Plant1/Ship2/Bullet1/dir_x; */
      r[226] = r[131];         /* Plant1/Ship2/Bullet1/D4/Pre1 = Plant1/Ship2/Bullet1/dir_y; */
      r[227] = r[137];         /* Plant1/Ship2/Bullet1/Integral1/Pre1 = Plant1/Ship2/Bullet1/relx; */
      r[228] = r[139];         /* Plant1/Ship2/Bullet1/Integral2/Pre1 = Plant1/Ship2/Bullet1/rely; */
      b[107] = b[49];          /* Plant1/Ship2/Pre1 = Plant1/Ship2/unfire; */
      i[8] = i[0];             /* Plant1/Hit1On2/Count2/Pre1 = hits1on2; */
      i[9] = i[1];             /* Plant1/Hit2On1/Count2/Pre1 = hits2on1; */
      b[108] = b[85];          /* MyAI1/Pre1 = MyAI1/left1; */
      b[109] = b[86];          /* MyAI1/Pre2 = MyAI1/right1; */
      r[229] = r[173];         /* MyAI1/AIThrust1/Derivative1/Pre1 = MyAI1/distance; */
   }
	
   /**
    * Finds the index of a signal given its name. The calling code can
    * use this function to retrieve the index to be used when reading
    * or writing in an array for a specific signal.
    * @param names The array of names to search; either boolNames, intNames or realNames.
    * @param name  The name of the signal to find the index for.
    * @return The index of the requested signal, or -1 if not found.
    */
   public static int findName(String[] names, String name) {
      for (int i = 0; i < names.length; i++) {
         if (names[i].equals(name)) {
            return i;
         }
      }
      return -1;
   }	
}

